Adornments in Angular Input Mask

25 Sep 20262 minutes to read

Adornments allow you to add custom elements before or after the Angular Input Mask input using the prependTemplate and appendTemplate properties. These templates support icons, labels, action buttons, and other visual elements while preserving mask validation and float label functionality.

Common Use Cases

  • Entry Guidance: Display icons or text that hints at the expected input format (e.g., a user icon for login fields).
  • Quick Actions: Include buttons for common operations such as submit, clear, or copy.
  • Context Labels: Add static text like country codes, domain names, or measurement units.
  • Visual Feedback: Show status indicators without affecting mask behavior.

Adding Adornments to Angular Input Mask

Use prependTemplate to render elements before the masked input, and appendTemplate to render elements after it. These templates support any inline HTML or icon markup and do not interfere with mask validation.

  • prependTemplate: Renders HTML content before the input field
  • appendTemplate: Renders HTML content after the input field

The following example shows how to implement adornments in the Angular Input Mask:

import { Component, ViewChild, ViewEncapsulation} from '@angular/core';
import { MaskedTextBoxModule } from '@syncfusion/ej2-angular-inputs';

@Component({
    selector: 'app-root',
    styleUrls: ['.././index.css'],
    template:`<div class="control-section adornment-mask">
    <div class="content-wrapper">
        <div class="mask-row">
            <ejs-maskedtextbox mask="0000-000-000" promptChar="#" cssClass="e-prepend-mask" placeholder="Enter phone number" floatLabelType="Auto" [prependTemplate]="prependTemplate" [appendTemplate]="appendTemplate">
                <ng-template #prependTemplate>
                    <span class="e-icons e-user"></span>
                    <span class="e-input-separator"></span>
                </ng-template>
                <ng-template #appendTemplate>
                    <span class="e-input-separator"></span>
                    <span class="e-icons e-send"></span>
                </ng-template>
            </ejs-maskedtextbox>
        </div>
    </div>
</div>`,
    standalone: true,
    encapsulation: ViewEncapsulation.None,
    imports: [MaskedTextBoxModule]
})
export class AppComponent {
    constructor() { }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

You can view the demo here: Angular Input Mask Adornments demo.

Adornments in React Input Mask

Adornments in the React Input Mask allow you to add custom elements before or after the masked input using the prependTemplate and appendTemplate properties. These elements can include prefixes, suffixes, labels, or action icons to provide context, guide input, and enable quick actions while preserving mask validation and float label behavior.

Common Use Cases

  • Entry Guidance: Add icons/text to hint the expected input (e.g., user icon for username/login).
  • Quick Actions: Include buttons to submit, clear, or copy the masked value.
  • Context Labels: Add static prefixes/suffixes like country code, domain, or unit suffix.
  • Visual Feedback: Show status indicators without interfering with the mask.

Adding Adornments to React Input Mask

Use prependTemplate and appendTemplate to inject HTML content before and after the masked input. These templates do not alter mask behavior and support any inline HTML or icon.

  • prependTemplate: Renders elements before the input.
  • appendTemplate: Renders elements after the input.

The following example demonstrates how to add adornments to the React Input Mask.

[Class-component]

import * as React from "react";
import * as ReactDOM from "react-dom";
import { MaskedTextBoxComponent } from '@syncfusion/ej2-react-inputs';

export default class App extends React.Component {
  prependTemplate = () => {
    return (
      <>
        <span className="e-icons e-user"></span>
        <span className="e-input-separator"></span>
      </>
    );
  };

  appendTemplate = () => {
    return (
      <>
        <span className="e-input-separator"></span>
        <span className="e-icons e-send"></span>
      </>
    );
  };

  render() {
    return (
      <div className="control-pane">
        <div className="control-section">
          <div className="content-wrapper">
            <div className="mask-row">
              <MaskedTextBoxComponent
                mask="000-000-0000"
                promptChar="#"
                cssClass="e-prepend-mask"
                placeholder="Enter phone number"
                floatLabelType="Auto"
                prependTemplate={this.prependTemplate}
                appendTemplate={this.appendTemplate}
              />
            </div>
          </div>
        </div>
      </div>
    );
  }
}
ReactDOM.render(<App />,document.getElementById('sample'));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MaskedTextBoxComponent } from '@syncfusion/ej2-react-inputs';

type Props = Record<string, never>;
type State = Record<string, never>;

export default class App extends React.Component<Props, State> {
  // Arrow methods ensure correct `this` context
  private prependTemplate = (): React.ReactNode => {
    return (
      <>
        <span className="e-icons e-user"></span>
        <span className="e-input-separator"></span>
      </>
    );
  };

  private appendTemplate = (): React.ReactNode => {
    return (
      <>
        <span className="e-input-separator"></span>
        <span className="e-icons e-send"></span>
      </>
    );
  };

  render(): React.ReactNode {
    return (
      <div className="control-pane">
        <div className="control-section">
          <div className="content-wrapper">
            <div className="mask-row">
              <MaskedTextBoxComponent
                mask="000-000-0000"
                promptChar="#"
                cssClass="e-prepend-mask"
                placeholder="Enter phone number"
                floatLabelType="Auto"
                prependTemplate={this.prependTemplate}
                appendTemplate={this.appendTemplate}
              />
            </div>
          </div>
        </div>
      </div>
    );
  }
}
ReactDOM.render(<App />,document.getElementById('sample'));

You can view the demo here: React Input Mask Adornments demo.

[Functional-component]

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useEffect } from 'react';

import { MaskedTextBoxComponent } from '@syncfusion/ej2-react-inputs';

function App() {
    const prependTemplate = () => {
        return (<>
            <span className="e-icons e-user"></span><span className="e-input-separator"></span>
        </>);
    };
    const appendTemplate = () => {
        return (<>
            <span className="e-input-separator"></span><span className="e-icons e-send"></span>
        </>);
    };
    return (<div className='control-pane'>
            <div className="control-section">
                <div className="content-wrapper">
                    <div className="mask-row">
                        <MaskedTextBoxComponent mask='000-000-0000' promptChar='#' cssClass='e-prepend-mask' placeholder='Enter phone number' floatLabelType='Auto' prependTemplate={prependTemplate} appendTemplate={appendTemplate}></MaskedTextBoxComponent>
                    </div>
                </div>
            </div>
        </div>);
};

ReactDOM.render(<App />,document.getElementById('sample'));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MaskedTextBoxComponent } from '@syncfusion/ej2-react-inputs';

function App(){
  const prependTemplate = (): React.ReactNode => (
    <>
      <span className="e-icons e-user"></span>
      <span className="e-input-separator"></span>
    </>
  );

  const appendTemplate = (): React.ReactNode => (
    <>
      <span className="e-input-separator"></span>
      <span className="e-icons e-send"></span>
    </>
  );

  return (
    <div className="control-pane">
      <div className="control-section">
        <div className="content-wrapper">
          <div className="mask-row">
            <MaskedTextBoxComponent
              mask="000-000-0000"
              promptChar="#"
              cssClass="e-prepend-mask"
              placeholder="Enter phone number"
              floatLabelType="Auto"
              prependTemplate={prependTemplate}
              appendTemplate={appendTemplate}
            />
          </div>
        </div>
      </div>
    </div>
  );
};

ReactDOM.render(<App />,document.getElementById('sample'));

You can view the demo here: React Input Mask Adornments demo.

Adornments in Vue MaskedTextBox

20 Aug 202612 minutes to read

Adornments in the MaskedTextBox control allow you to add custom elements before or after the masked input using the prependTemplate and appendTemplate properties. These elements can include prefixes, suffix labels, or action icons to provide context, guide user input, and offer quick actions while preserving mask validation and float label behavior.

Common Use Cases

  • Entry Guidance: Add icons/text to hint the expected input (e.g., user icon for username/login).
  • Quick Actions: Include buttons to submit, clear, or copy the masked value.
  • Context Labels: Add static prefixes/suffixes like country code, domain, or unit suffix.
  • Visual Feedback: Show status indicators without interfering with the mask.

Adding Adornments to MaskedTextBox

Use prependTemplate and appendTemplate to inject HTML content before and after the masked input respectively. These templates do not alter mask behavior and support any inline HTML or icon.

  • prependTemplate: Renders elements before the masked input.
  • appendTemplate: Renders elements after the masked input.

The following example demonstrates how to add adornments in the MaskedTextBox control.

<template>
    <div>
        <div class="col-lg-12 control-section adornment-mask">
            <div class="content-wrapper">
                <div class="mask-row">
                    <ejs-maskedtextbox id="maskTextbox" mask="0000-000-000" promptChar="#" floatLabelType="Auto" cssClass="e-prepend-mask" placeholder="Enter phone number" :prependTemplate="'prependTemplate'" :appendTemplate="'appendTemplate'">
                        <template v-slot:prependTemplate>
                            <span id="user" class="e-icons e-user" title="User"></span>
                            <span class="e-input-separator"></span>
                        </template>
                        <template v-slot:appendTemplate>
                            <span class="e-input-separator"></span>
                            <span id="sendIcon" class="e-icons e-send"></span>
                        </template>
                    </ejs-maskedtextbox>
                </div>
            </div>
        </div>
    </div>
</template>

<style>
    .adornment-mask .content-wrapper div.mask-row {
        max-width: 250px;
        margin: 0 auto;
        padding: 40px 0px 0px;
    }
    .adornment-mask .multiline-property td {
        padding: 10px 0px;
        width: 50%;
    }
    .mask-row label.e-float-text, .e-float-input:not(.e-error):not(.e-input-focus) input:not(:focus):valid~label.e-float-text.e-label-bottom, .e-float-input.e-control-wrapper:not(.e-error):not(.e-input-focus) input:not(:focus):valid~label.e-float-text.e-label-bottom {
        margin-top: -2px;
    }
    .bootstrap5\.3 .mask-row .e-float-text,
    .bootstrap5\.3-dark .mask-row .e-float-text,
    .tailwind3 .mask-row .e-float-text,
    .tailwind3-dark .mask-row .e-float-text {
        padding-left: 0 !important;
    }
    .fluent2 .mask-row .e-label-bottom,
    .fluent2-dark .mask-row .e-label-bottom,
    .fluent2-highcontrast .mask-row .e-label-bottom {
        top: -8px !important;
    }
    .bootstrap5_3 .adornment-mask .e-prepend-template,
    .bootstrap5_3-dark .adornment-mask .e-prepend-template {
        padding-right: 0 !important;
    }
    .e-bigger.material3 .adornment-mask label.e-float-text.e-label-bottom,
    .e-bigger.material3-dark .adornment-mask label.e-float-text.e-label-bottom {
        top: -4px !important;
    }
    .e-bigger.bootstrap5_3 .adornment-mask label.e-float-text.e-label-bottom,
    .e-bigger.bootstrap5_3-dark .adornment-mask label.e-float-text.e-label-bottom {
        top: 20px !important;
    }
</style>

<script setup>
import { MaskedTextBoxComponent } from "@syncfusion/ej2-vue-inputs";
import { getComponent } from '@syncfusion/ej2-base';
import { onMounted } from 'vue';

// Lifecycle hook for event listeners (optional if no events needed)
onMounted(() => {
    // Add event listeners if needed
    // Example: const userIcon = document.querySelector('#user');
    // if (userIcon) {
    //     userIcon.addEventListener('click', () => {
    //         // Handle user icon click
    //     });
    // }
    // const sendIcon = document.querySelector('#sendIcon');
    // if (sendIcon) {
    //     sendIcon.addEventListener('click', () => {
    //         // Handle send icon click
    //     });
    // }
});
</script>
<template>
    <div>
        <div class="col-lg-12 control-section adornment-mask">
            <div class="content-wrapper">
                <div class="mask-row">
                    <ejs-maskedtextbox id="maskTextbox" mask="0000-000-000" promptChar="#" floatLabelType="Auto" cssClass="e-prepend-mask" placeholder="Enter phone number" :prependTemplate="'prependTemplate'" :appendTemplate="'appendTemplate'">
                        <template v-slot:prependTemplate>
                            <span id="user" class="e-icons e-user" title="User"></span>
                            <span class="e-input-separator"></span>
                        </template>
                        <template v-slot:appendTemplate>
                            <span class="e-input-separator"></span>
                            <span id="sendIcon" class="e-icons e-send"></span>
                        </template>
                    </ejs-maskedtextbox>
                </div>
            </div>
        </div>

    </div>
</template>

<script>
import { MaskedTextBoxComponent } from "@syncfusion/ej2-vue-inputs";
import { getComponent } from '@syncfusion/ej2-base';

export default {
    data: function() {
        return {};
    },
    components: { 
        'ejs-maskedtextbox': MaskedTextBoxComponent
    },
};

</script>
<style>
    .adornment-mask .content-wrapper div.mask-row {
        max-width: 250px;
        margin: 0 auto;
        padding: 40px 0px 0px;
    }
    .adornment-mask .multiline-property td {
        padding: 10px 0px;
        width: 50%;
    }
    .mask-row label.e-float-text, .e-float-input:not(.e-error):not(.e-input-focus) input:not(:focus):valid~label.e-float-text.e-label-bottom, .e-float-input.e-control-wrapper:not(.e-error):not(.e-input-focus) input:not(:focus):valid~label.e-float-text.e-label-bottom {
        margin-top: -2px;
    }
    .bootstrap5\.3 .mask-row .e-float-text,
    .bootstrap5\.3-dark .mask-row .e-float-text,
    .tailwind3 .mask-row .e-float-text,
    .tailwind3-dark .mask-row .e-float-text {
        padding-left: 0 !important;
    }
    .fluent2 .mask-row .e-label-bottom,
    .fluent2-dark .mask-row .e-label-bottom,
    .fluent2-highcontrast .mask-row .e-label-bottom {
        top: -8px !important;
    }
    .bootstrap5_3 .adornment-mask .e-prepend-template,
    .bootstrap5_3-dark .adornment-mask .e-prepend-template {
        padding-right: 0 !important;
    }
    .e-bigger.material3 .adornment-mask label.e-float-text.e-label-bottom,
    .e-bigger.material3-dark .adornment-mask label.e-float-text.e-label-bottom {
        top: -4px !important;
    }
    .e-bigger.bootstrap5_3 .adornment-mask label.e-float-text.e-label-bottom,
    .e-bigger.bootstrap5_3-dark .adornment-mask label.e-float-text.e-label-bottom {
        top: 20px !important;
    }
</style>

You can view the demo here: MaskedTextBox Adornments demo.